package com.malk.ruisi.controller;


import cn.hutool.http.HttpUtil;
import cn.hutool.json.ObjectMapper;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.JsonNode;
import com.malk.ruisi.service.RsQysService;
import com.malk.ruisi.service.dingshiqi;
import com.malk.ruisi.service.impl.dingshiqiImpl;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDConf;
import com.malk.service.aliwork.YDClient;
import com.malk.service.dingtalk.DDClient;
import com.malk.utils.UtilHttp;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringEscapeUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;
import java.net.MalformedURLException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;

@RestController
@Slf4j
@RequestMapping("/qys")
public class QysHuiDaoController {
    @Autowired
    private RsQysService qysService;
    @Autowired
    private YDClient ydClient;
    @Autowired
    private YDConf ydConf;
    @Autowired
    private DDConf ddConf;
    @Autowired
    private DDClient ddClient;
    @PostMapping("/person")
    //传入实例Id获取实例数据
    public McR person(@RequestBody Map map) throws Exception {
        log.info("param:{}", map);
        List<String> list = (List<String>) map.get("formInstanceId");
        List<String> result = new ArrayList<>();
        for (String s : list) {
            Map formData = (Map) ydClient.queryData(YDParam.builder().formInstId(s)
                    .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                    .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
            log.info("formData:{}", formData);

            List<String> aa2 = (List<String>) formData.get("employeeField_lwr509pq");
            System.out.println(aa2);
            //用for循环遍历一下aa2集合
            result.addAll(aa2);
        }
        Set<String> result1 = new HashSet<>(result);
        List<Map> r = new ArrayList<>();
        for (String s1 : result1) {
            Map<String, String> name1 = new HashMap<>();
            int start = s1.indexOf('(');
            int end = s1.indexOf(')');
            if (start != -1 && end != -1) {
                String name = s1.substring(0, start);
                String id = s1.substring(start + 1, end);
                name1.put("label", name);
                name1.put("value", id);
            }
            r.add(name1);
        }
        return McR.success(r);
    }
    @GetMapping("/test1" )
    public String test1() throws Exception {
//        List<Map> list = (List<Map>) ydClient.queryData(YDParam.builder().formUuid("FORM-5DB656AF0F0E4EFA85A4739D55C23ED85BXO")
//                .searchFieldJson(JSONObject.toJSONString(UtilMap.map("serialNumberField_lvz8coae", "HT02-KJLHEYY-202407240029")))
//                .build(), YDConf.FORM_QUERY.retrieve_list).getData();
        Map data = (Map) ydClient.queryData(YDParam.builder().formInstId("6a1ca03a-1d9c-4906-a328-881741543db8")
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        System.out.println("qaqqaq------------"+data);
        String json = data.get("associationFormField_lvz8coby"+"_id").toString();
        System.out.println("zzzz==========="+json);
        String s = StringEscapeUtils.unescapeJava(json.substring(1, json.length() - 1));
        List<Map> list1 = (List<Map>) JSONArray.parse(s);
        for (Map map2 : list1) {
            JSONObject auths = new JSONObject();
            String subTitle = (String) map2.get("instanceId");
            Map data1 = (Map) ydClient.queryData(YDParam.builder().formInstId(subTitle)
                    .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                    .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
            System.out.println("niu==================="+data1);
            String aa = (String) data1.get("textField_lwywohh0");
            String aa1 = (String) data1.get("textField_lw6aecve");
//            String aa2 = (String) data1.get("employeeField_lwr509pq_id");
            ArrayList<Object> objects = new ArrayList<>();
            Map hashMap = new HashMap();
            hashMap.put("mobile",aa);
            objects.add(hashMap);
            auths.put("sealName", aa1);//印章名称
            auths.put("count", 3);//授权数量
            auths.put("users", objects);
            System.out.println("qaq"+auths);
//            System.out.println("qqqq"+subTitle);
        }
//        System.out.println("sssss======"+list1);
//        log.info("list:{}", list);
//        Map map = list.get(0);
//        Map formData = (Map) map.get("formData");
//        String json1 = formData.get("associationFormField_lvz8coby"+"_id").toString();
//        System.out.println("zzzz"+json1);
//        String s1 = StringEscapeUtils.unescapeJava(json.substring(1, json.length() - 1));
//        List<Map> list2 = (List<Map>) JSONArray.parse(s1);
//        System.out.println("zzzz"+list1);
//        for (Map map1 : list1) {
//            JSONObject auths = new JSONObject();
//
//            Object subTitle = map1.get("title");
//            ArrayList<Object> objects = new ArrayList<>();
//            auths.put("sealName", subTitle);//印章名称
//            auths.put("count", 3);//授权数量
//            System.out.println("qaq"+auths);
//            System.out.println("qqqq"+subTitle);
//        }
return "success";
    }
    @GetMapping("/test2")
    public String test2() throws Exception {
        dingshiqiImpl dingshiqi = new dingshiqiImpl();
//        String sn = param.get("sn");
//        String[] sns = sn.split("-");
//        Map<String, String> formUuid = getFormUuid(sns[0]);
        List<Map> list1 = (List<Map>) ydClient.queryData(YDParam.builder().formUuid("FORM-5DB656AF0F0E4EFA85A4739D55C23ED85BXO")
                .searchFieldJson(JSONObject.toJSONString(UtilMap.map("serialNumberField_lvz8coae", "HT02-KJLHEYY-202408090037")))
                .build(), YDConf.FORM_QUERY.retrieve_list).getData();
        Map map = list1.get(0);
        String instanceId = (String) map.get("formInstanceId");
        Map param2 = new HashMap();
        param2.put("x-acs-dingtalk-access-token", dingshiqi.getAccessToken_PJSS());
        Map body3 = new HashMap();
        body3.put("appType","APP_VCTRP6227CC8368NDOID");
        body3.put("systemToken","5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
        body3.put("processInstanceId", instanceId);
        body3.put("userId","13810479803");
        boolean flag=true;
        do {
            String s = UtilHttp.doGet("https://api.dingtalk.com/v1.0/yida/processes/operationRecords", param2, (Map<String, Object>) body3);
            JSONObject obj=JSONObject.parseObject(s);
            JSONArray arr = obj.getJSONArray("result");
            for (int i = 0; i < arr.size(); i++) {
                JSONObject json = arr.getJSONObject(i);
                flag=false;
//                if(json.getString("operatorUserId").equals("13810479803")&&json.getString("type").equals("TODO")){
                    try {
                        taskExecute("0f3433c2-f9db-40ab-929b-3e8119d66c84",json.getString("taskId"));
                    }catch (McException e){
                        log.error("taskExecute error:{}",e.getMessage());
                    }

                    flag=true;
                    break;

//                }
            }
        }while (flag);
        return "success";
    }
//    @GetMapping("/test" )
//    public String test() throws Exception {
//        dingshiqiImpl dingshiqi = new dingshiqiImpl();
//        List<Map> list = (List<Map>) ydClient.queryData(YDParam.builder().formUuid("FORM-5DB656AF0F0E4EFA85A4739D55C23ED85BXO")
//                .searchFieldJson(JSONObject.toJSONString(UtilMap.map("serialNumberField_lvz8coae", "HT02-KJLHEYY-202408090036")))
//                .build(), YDConf.FORM_QUERY.retrieve_list).getData();
//        log.info("list:{}", list);
//        Map map = list.get(0);
//        String instanceId = (String) map.get("formInstanceId");
//        Map formData = (Map) map.get("formData");
//        String lss = formData.toString();
//        String json = formData.get("associationFormField_lzaq7kz8_id").toString();
//        String s = StringEscapeUtils.unescapeJava(json.substring(1, json.length() - 1));
//        List<Map> list1 = (List<Map>) JSONArray.parse(s);
//        System.out.println("zzzz"+list1);
//        for (Map map1 : list1) {
//            Object subTitle = map1.get("subTitle");
//            System.out.println("qqqq"+subTitle);
//        }
//
////        List<String> subTitleValues = getSubTitles(formData);
//        Map param2 = new HashMap();
//        param2.put("x-acs-dingtalk-access-token", dingshiqi.getAccessToken_PJSS());
//        System.out.println("x-acs-dingtalk-access-token"+ddClient.getAccessToken());
//        Map body3 = new HashMap();
////        body3.put("outResult","AGREE");
//        body3.put("appType","APP_VCTRP6227CC8368NDOID");
//        body3.put("systemToken","5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
////        body3.put("remark","同意");
//        body3.put("processInstanceId", instanceId);
//        body3.put("userId","13810479803");
//        boolean flag=true;
//        do {
//            String s = UtilHttp.doGet("https://api.dingtalk.com/v1.0/yida/processes/operationRecords", param2, (Map<String, Object>) body3);
//            System.out.println("555"+s);
//            JSONObject obj=JSONObject.parseObject(s);
//            JSONArray arr = obj.getJSONArray("result");
//            for (int i = 0; i < arr.size(); i++) {
//                JSONObject json = arr.getJSONObject(i);
//                flag=false;
//                if(json.getString("operatorUserId").equals("13810479803")&&json.getString("type").equals("TODO")){
//                    taskExecute(instanceId,json.getString("taskId"));
//                    flag=true;
//                    break;
//                }
//            }
//        }while (flag);
//        return "success";
//    }
    private void taskExecute(String instanceId,String taskId){
        Map param3 = new HashMap();
        param3.put("x-acs-dingtalk-access-token",new dingshiqiImpl().getAccessToken_PJSS());
        Map body4 = new HashMap();
        body4.put("outResult","AGREE");
        body4.put("appType","APP_VCTRP6227CC8368NDOID");
        body4.put("systemToken","5H9662C1X8XJLFFCE841M5VBEBQ73DM5IBPULPI3");
        body4.put("remark","同意");
        body4.put("taskId",taskId);
        body4.put("processInstanceId", instanceId);
        body4.put("userId","13810479803");
        String s1 = UtilHttp.doPost("https://api.dingtalk.com/v1.0/yida/tasks/execute", param3,null, (Map<String, Object>) body4);
        System.out.println("result"+s1);
    }
    /***
     * 第三步
     * 契约锁签署完成回调、保存文件
     * @return
     */
    @PostMapping("/callback")
    public String  callback(@RequestParam Map<String, String> param) throws Exception {
        log.info("callback:{}", param);

        //1.content解析为json字符   并获得contractId
        //2.根据contractId 获取附件到本地获得一个本地地址  接口：/contract/download zip保存到本地   并解压zip

        //3.根据contractId查询对应的数据实例ID，根据实例ID把本地地址对的文件传到对应的 附件签署后

        //("attachmentField_ltsbweit",文件)
        return qysService.callback(param);
    }
    @PostMapping("/callback1")
    public String  callback1(@RequestParam Map<String, String> param) throws Exception {
        log.info("callback:{}", param);

        return qysService.callback1(param);
    }

    private static final String FILE_DIRECTORY = "/home/server/ruisi_qys/ruisi_qiyuesuo/fils_new/";

    @GetMapping("/download/{sn}/{fileName}")
    public ResponseEntity<Resource> downloadFile(@PathVariable String fileName,@PathVariable String sn) {
        Path filePath = Paths.get(FILE_DIRECTORY.concat(sn.concat("//"))).resolve(fileName).normalize();
        try {
            Resource resource = new UrlResource(filePath.toUri());
            if (resource.exists()) {
                HttpHeaders headers = new HttpHeaders();
                headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=" + resource.getFilename());
                return ResponseEntity.ok()
                        .headers(headers)
                        .contentType(MediaType.parseMediaType("application/octet-stream"))
                        .body(resource);
            } else {
                return ResponseEntity.notFound().build();
            }
        } catch (MalformedURLException e) {
            return ResponseEntity.notFound().build();
        } catch (IOException e) {
            return ResponseEntity.notFound().build();
        }
    }
}



